

do

	asteroid = {
		list = {},
		count = 0,
	}

	function asteroid.load()
		asteroid.image = love.graphics.newImage("media/asteroid.png")
	end

	function asteroid.clear()
		asteroid.list = {}
		asteroid.count = 0
	end

	function asteroid.create(x, y, vx, vy, scale)
		scale = scale or 1.0
		vx = vx or 0.0
		vy = vy or 0.0
		-- valid position?
		if x > portal.x - 400 then
			return nil
		end
		-- Create
		local obj = {
			x = x,
			y = y,
			vx = vx,
			vy = vy,
			scale = scale,
			rad = 80*scale,
			va = rnd(0.3,1.0) * (rnd() > 0.5 and 1 or -1),
			angle = rnd(PI2),
			hp = 300,
		}
		asteroid.count = asteroid.count + 1
		table.insert(asteroid.list, obj)
		return obj
	end

	function asteroid.createRandom()
		return asteroid.create(spaceship.instance.x + rnd(1000,2700), rnd(-gameState.maxHeight,gameState.maxHeight), rnd(-80,70), rnd(-150,150), rnd(0.5,1.0))
	end

	function asteroid.deleteID(id)
		table.remove(asteroid.list, id)
		asteroid.count = asteroid.count - 1
	end

	function asteroid.delete(obj)
		for i = 1,asteroid.count do
			if asteroid.list[i] == obj then
				asteroid.deleteID(i)
				return true
			end
		end
		return false
	end


	function asteroid.update()
		for i = asteroid.count, 1, -1 do
			asteroid.updateInstance(asteroid.list[i])
		end
	end

		function asteroid.updateInstance(obj)
			-- Move
			obj.x = obj.x + obj.vx * gameState.dt
			obj.y = obj.y + obj.vy * gameState.dt
			obj.angle = obj.angle + obj.va * gameState.dt
			-- Bounds
			if obj.y < -gameState.maxHeight then obj.y =  gameState.maxHeight end
			if obj.y >  gameState.maxHeight then obj.y = -gameState.maxHeight end
			if obj.x < spaceship.instance.x - 400 then
				asteroid.createRandom()
				asteroid.delete(obj)
			end
		end

	function asteroid.draw()
		love.graphics.setColor(255,255,255,255)
		for i = 1,asteroid.count do
			asteroid.drawInstance(asteroid.list[i])
		end
	end

		function asteroid.drawInstance(obj)
			love.graphics.draw(asteroid.image, obj.x, obj.y, obj.angle, obj.scale*0.4, obj.scale*0.4, 256, 256)
			local dy = ((obj.y < 0) and 2 or -2) * gameState.maxHeight
			love.graphics.draw(asteroid.image, obj.x, obj.y+dy, obj.angle, obj.scale*0.4, obj.scale*0.4, 256, 256)
		end



	function asteroid.sphereCollision(x,y,r)
		local a
		for i = 1,asteroid.count do
			a = asteroid.list[i]
			if collision.sphereSphere(x,y,r, a.x,a.y,a.rad) then
				asteroid.collider = a
				return a
			end
		end
		return nil
	end

	function asteroid.damage(a, dmg)
		a.hp = a.hp - dmg
		if a.hp <= 0 then
			pickups.createRandom(a.x, a.y)
			local newA = asteroid.createRandom()
			if newA then
				newA.x = newA.x + 1200 -- slight break after destroying an asteroid
			end
			asteroid.delete(a)
		end
	end



end