
do

	explosion = {
		count = 0,
		list = {},
		quads = {}
	}

	function explosion.load()
		explosion.image = love.graphics.newImage("media/explosion.png")
		local i = 0
		local sw, sh = explosion.image:getDimensions()
		for y = 0,4 do
			for x = 0,5 do
				i = i + 1
				explosion.quads[i] = love.graphics.newQuad(320*x, 320*y, 320, 320, sw, sh)
			end
		end
	end

	function explosion.clear()
		explosion.count = 0
		explosion.list = {}
	end

	function explosion.create(x,y,scalefac,timefac,alpha)
		local obj = {
			x = x,
			y = y,
			p = 0.0,
			angle = rnd(PI2),
			scale = rnd(0.8,1.0) * (scalefac or 1.0),
			timescale = 1.2 * (timefac or 1.0),
			alpha = alpha or 1.0
		}
		explosion.count = explosion.count + 1
		table.insert(explosion.list, obj)
		-- sound
		if scalefac >= 0.6 then
			lush.play("explosion.wav")
		end
		return obj
	end

	function explosion.deleteId(i)
		explosion.count = explosion.count - 1
		table.remove(explosion.list, i)
	end

	function explosion.draw()
		for i = explosion.count,1,-1 do
			if explosion.drawInstance(explosion.list[i]) then explosion.deleteId(i) end
		end
	end

		function explosion.drawInstance(e)
			-- update age
			e.p = e.p + gameState.dt * e.timescale
			if e.p >= 1.0 then return true end
			-- draw
			love.graphics.setColor(255,230,230,255*e.alpha)
			local frame = math.floor(1 + #explosion.quads * e.p)
			love.graphics.draw(explosion.image, explosion.quads[frame], e.x, e.y, e.angle, e.scale, e.scale, 160, 160)
		end

end