
do

	gameState = {
		maxHeight = 400,
		dt = 0,
		time = 0,
		prevtime = 0,
	}

	camera = {
		x = 0,
		y = 0,
		scale = 1,
	}

	function gameState.enter()
		gameState.level = gameState.level + 1
		if gameState.level > 3 then
			endGame()
		end
		if gameState.level == 2 then
			-- give weapons to player
			spaceship.enhanceWeapon(1)
			spaceship.saveState()
		end
		gameState.resetLevel()
	end

	function gameState.load()
		bullets.load()
		spaceship.create()
		portal.load()
		asteroid.load()
		enemy.load()
		spaceship.load()
		pickups.load()
		explosion.load()
		background.load()
		gameState.level = 0
		spaceship.saveState()
	end

	function gameState.resetLevel()
		gameState.clearLevel()
		spaceship.reset()
		spaceship.loadState()
		levelBuilder.build(gameState.level)
		for i = 1,0 do
			enemy.create(enemy.types[2], 2000, 0, i*0.5, {{"straight", 200, 100, 1},{"wave", 50, 50, 5}})
			enemy.create(enemy.types[1], 1200, 0, i*0.3, {{"circle", 120, 120, 2}, {"wave", 0, 60, 2}, {"wavex", 80, 0, 1.2}})
			enemy.create(enemy.types[1], 2700, 0, i*0.3, {{"circle", 120, 120, 2}, {"wave", 0, 60, 2}, {"wavex", 80, 0, 1.2}})
			enemy.create(enemy.types[1], 4200, 0, i*0.3, {{"circle", 120, 120, 2}, {"wave", 0, 60, 2}, {"wavex", 80, 0, 1.2}})
		end
	end

	function gameState.clearLevel()
		bullets.clear()
		enemy.clear()
		asteroid.clear()
		pickups.clear()
		explosion.clear()
	end

	function gameState.endLevel()
		spaceship.saveState()
		setState(sequences)
	end

	function gameState.draw()
		love.graphics.push()
			gameState.updateCam()
			background.draw()
			portal.draw(false, 1.0, 1.0)
			portal.draw(false, -1.3, 0.3)
			love.graphics.setScissor(0,0,portal.scissorX,love.window.getHeight())
				bullets.draw()
				pickups.draw()
				spaceship.draw()
				enemy.draw()
				asteroid.draw()
				explosion.draw()
			love.graphics.setScissor()
			portal.draw(true, 1.0, 1.0)
			portal.draw(true, -1.3, 0.3)
		love.graphics.pop()
	end

	function gameState.update(dt)
		gameState.dt = dt
		spaceship.update()
		enemy.update()
		asteroid.update()
		bullets.update()
		gameState.updateLogics()
	end



	function gameState.updateCam()
		camera.x = spaceship.instance.x - love.window.getWidth()*0.2
		love.graphics.translate(-spaceship.instance.x, 0)
		love.graphics.translate(love.window.getWidth()*0.2, love.window.getHeight()/2)
	end

	function gameState.updateLogics()
		-- level end?
		if spaceship.instance.x > portal.x then
			gameState.endLevel()
		end
	end

	function gameState.keypressed(key)
		spaceship.handleKeypress(key)
	end



	function gameState.wrapY(y)
		return ((y + gameState.maxHeight) % (2*gameState.maxHeight)) - gameState.maxHeight
		--if y > gameState.maxHeight then y = -gameState.maxHeight elseif y < -gameState.maxHeight then y = gameState.maxHeight end
		--return y
	end

	function gameState.outside(y)
		return (y < -gameState.maxHeight or y > gameState.maxHeight)
	end

	function gameState.periodicCheck(delay)
		return math.floor(gameState.prevtime/delay) < math.floor(gameState.time/delay)
	end


end