
do

	pickups = {
		types = {},
		list = {},
		count = 0,
	}

	function pickups.load()
		-- create types
		pickups.image = love.graphics.newImage("media/pickup.png")
		pickups.shineImage = love.graphics.newImage("media/pickup_shine.png")
		--pickups.addType("Shield", {0,120,255}, function(ship) ship.shield = ship.maxShield end) -- refills shield
		--pickups.addType("Power", {255,128,0}, function(ship) ship.powerTime = 10.0 end) -- double damage for 10 seconds
		pickups.addType("Laser", {255,0,0}, bullets.types[1].sprite, function(ship) spaceship.enhanceWeapon(1) end)
		pickups.addType("Pulse", {255,255,0}, bullets.types[2].sprite, function(ship) spaceship.enhanceWeapon(2) end)
		pickups.addType("Rocket", {160,160,160}, bullets.types[3].sprite, function(ship) spaceship.enhanceWeapon(3) end)
		pickups.addType("Phaser", {0,255,255}, bullets.types[4].sprite, function(ship) spaceship.enhanceWeapon(4) end)
	end

	function pickups.clear()
		pickups.list = {}
		pickups.count = 0
	end

	function pickups.addType(name, color, sprite, applyFunction)
		local obj = {
			name = name,
			color = color,
			sprite = sprite,
			applyFunction = applyFunction
		}
		pickups.types[#pickups.types+1] = obj
		return obj
	end


	function pickups.create(tp, x, y)
		if type(tp) == "number" then tp = pickups.types[tp] end
		local obj = {
			type = tp,
			x = x,
			y = y,
		}
		table.insert(pickups.list, obj)
		pickups.count = pickups.count + 1
		return obj
	end

	function pickups.deleteID(id)
		table.remove(pickups.list, id)
		pickups.count = pickups.count - 1
	end

	function pickups.delete(p)
		for i = 1,pickups.count do
			if pickups.list[i] == p then
				pickups.deleteID(i)
				return true
			end
		end
		return false
	end

	function pickups.createRandom(x,y)
		local x = x or (spaceship.instance.x + rnd(1200,2400))
		local y = y or (rnd(-350,350))
		local tp = math.ceil(rnd(0.0,#pickups.types-0.01))
		pickups.create(tp, x, y)
	end


	function pickups.draw()
		for i = 1,pickups.count do
			pickups.drawInstance(pickups.list[i])
		end
	end

		function pickups.drawInstance(p)
			-- Shiny background
			love.graphics.setColor(p.type.color[1], p.type.color[2], p.type.color[3], 100)
			love.graphics.draw(pickups.shineImage, p.x, p.y,  gameState.time*0.74, 0.48, 0.48, 64, 64)
			love.graphics.draw(pickups.shineImage, p.x, p.y, -gameState.time*0.51, 0.55, 0.55, 64, 64)
			love.graphics.setColor(255,255,255,128)
			love.graphics.draw(pickups.shineImage, p.x, p.y,  gameState.time*0.36, 0.5, 0.5, 64, 64)
			-- Colored Circle
			love.graphics.setColor(p.type.color[1]*0.5, p.type.color[2]*0.5, p.type.color[3]*0.5)
			love.graphics.circle("fill", p.x, p.y, 15)
			-- actual Sprite
			love.graphics.setColor(255,255,255,255)
			love.graphics.draw(p.type.sprite, p.x, p.y, 0, 0.2,0.2, 64,64)
			-- Overlay
			love.graphics.draw(pickups.image, p.x, p.y, 0, 0.58,0.58, 32,32)
		end

	function pickups.sphereCollision(x,y,r)
		local p
		for i = 1,pickups.count do
			p = pickups.list[i]
			if collision.sphereSphere(x,y,r, p.x,p.y,20) then
				pickups.collider = p
				return p
			end
		end
		return nil
	end

	function pickups.apply(p, ship)
		p.type.applyFunction(ship)
		print("Applied pickup " .. p.type.name)
		pickups.delete(p)
	end



end